#!/usr/bin/python -u
# -*- coding: utf-8 -*-
# ↑もともとはEmacsで文字コードを強制するときのタグですが、Python自身がファ
# イルの文字コードを判定するためにも使います。判定した文字コードと実際の文
# 字コードが一致していない場合、たとえコメント中であってもエラーになります。
# コマンド引数の「-u」は標準出力をノンバッファリングモードに指定しています。

### 送信用スクリプトです。なお、Cygwinではcygwin1.dllの関係でIPv6が使えません。

import sys
from socket import * # 本来'*'でインポートすることは推奨されないようです。
from time import sleep
from itertools import count
from mcconfig import *

# 引数でIPv4/IPv6を切り替えます。
if len(sys.argv) > 1 and sys.argv[1] == '6':
    domain = AF_INET6
    addr = MULTICAST_ADDR6
    print "Mode: IPv6"
else:
    domain = AF_INET
    addr = MULTICAST_ADDR4
    print "Mode: IPv4"

sock = socket(domain, SOCK_DGRAM)
maddr = getaddrinfo(addr, MULTICAST_PORT, domain, SOCK_DGRAM)[0][-1]

# 送信処理
# ジェネレータでカウントアップしています。
for i in count(1):
    sock.sendto(str(i) + " " + SEND_NAME, maddr)
    sleep(SEND_INTERVAL / 1000.0) # ミリ秒→秒
