%%% -*- coding: utf-8 -*-
%%% ↑Emacsで文字コードを強制するときのタグです。

%%% モジュール名はファイルのベース名と一致させます。
%%% モジュール名には、文字列ではなくアトム(≒シンボル)を指定します。
%%% 小文字から始まる名前がアトムになります。
-module(sender).

-export([main/1]).

%%% includeはマクロプロセッサで処理されます。escriptでは使えないようです。
-include("mcconfig.hrl").

%%% 送信用プロセスのメインループです。
loop(Socket, Ip, Cnt) ->
    gen_udp:send(Socket, Ip, ?MULTICAST_PORT,
                 list_to_binary(io_lib:format("~p " ++ ?SEND_NAME, [Cnt]))),
    timer:sleep(?SEND_INTERVAL),
    loop(Socket, Ip, Cnt + 1).

%%% 送信用プロセスの開始点です。起動時にコマンドラインから指定します。
main(Arg) ->
    %% 引数でIPv4/IPv6を切り替えます。
    if Arg == ['6'] ->
            Inet = inet6,
            Addr = ?MULTICAST_ADDR6,
            io:format("Mode: IPv6~n", []);
       true ->
            Inet = inet,
            Addr = ?MULTICAST_ADDR4,
            io:format("Mode: IPv4~n", [])
    end,
    {ok, Socket} = gen_udp:open(0, [binary, Inet]),
    {ok, Ip} = inet:getaddr(Addr, Inet),
    loop(Socket, Ip, 1).
