package mywebserver;

import static java.net.HttpURLConnection.HTTP_NOT_FOUND;
import static java.net.HttpURLConnection.HTTP_NOT_IMPLEMENTED;
import static java.net.HttpURLConnection.HTTP_OK;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.net.URI;

/**
 * HTTPNGXgnhONXB
 */
public class HttpHandler {

    /**
     * hLg[gfBNgB
     */
    private final File documentRoot;

    /**
     * fBNgCfbNX̃t@CB
     */
    private final String directoryIndex;

    /**
     * HTTPnhIuWFNg\z܂B
     * 
     * @param path
     *            hLg[gfBNg̃pXB
     * @param directoryIndex
     *            fBNgCfbNX̃t@CB
     */
    public HttpHandler(String path, String directoryIndex) {
        documentRoot = new File(path);
        this.directoryIndex = directoryIndex;
    }

    /**
     * HTTPNGXg̃nhOJn܂B<br>
     * \bhɏU蕪܂B<br>
     * ΉĂȂ\bh̏ꍇ Status-Code 501 Not Implemented 𑗐M܂B<br>
     * NGXgURIŎw肳ꂽt@CI[vłȂꍇ Status-Code 404 Not Found 𑗐M܂B
     * 
     * @param req
     *            NGXgIuWFNgB
     * @param res
     *            X|XIuWFNgB
     * @throws IOException
     *             o͗OB
     */
    public void handle(Request req, Response res) throws IOException {
        try {
            if ("GET".equals(req.getMethod())) {
                doGet(req, res);
            } else if ("HEAD".equals(req.getMethod())) {
                doHead(req, res);
            } else {
                // ΉĂȂ\bh̏ꍇ
                res.sendResponseHeader(HTTP_NOT_IMPLEMENTED);
            }
        } catch (FileNotFoundException e) {
            // w肳ꂽt@CȂꍇ
            res.sendResponseHeader(HTTP_NOT_FOUND);
        }
    }

    /**
     * NGXgURIŎw肳ꂽt@C̓Xg[ƂĎ擾܂B<br>
     * ̓Xg[I[vłꍇ Status-Code 200 OK 𑗐M܂B
     * 
     * @param req
     *            NGXgIuWFNgB
     * @param res
     *            X|XIuWFNgB
     * @return w肳ꂽt@C̓̓Xg[B
     * @throws FileNotFoundException
     *             NGXgURIŎw肳ꂽt@CI[vłȂꍇɔB
     * @throws IOException
     *             o͗OB
     */
    private InputStream getContentInputStream(Request req, Response res)
            throws FileNotFoundException, IOException {
        File content = getContent(req.getRequestUri());
        InputStream is = new FileInputStream(content);
        res.setHeader("Content-Type", Utils.getMediaType(content));
        res.setHeader("Content-Length", Long.toString(content.length()));
        return is;
    }

    /**
     * NGXgURIŎw肳ꂽt@CIuWFNg擾܂B<br>
     * w肳ꂽpXfBNg̏ꍇ́AfBNgCfbNXt@CԂ܂B
     * 
     * @param requestUri
     *            NGXgURIB
     * @return t@CIuWFNgB
     */
    private File getContent(URI requestUri) {
        File content = new File(documentRoot, requestUri.getPath());
        if (content.isDirectory()) {
            return new File(content, directoryIndex);
        }
        return content;
    }

    /**
     * HEAD\bh܂B
     * 
     * @param req
     *            NGXgIuWFNgB
     * @param res
     *            X|XIuWFNgB
     * @throws IOException
     * @throws FileNotFoundException
     */
    private void doHead(Request req, Response res) throws IOException,
            FileNotFoundException {
        getContentInputStream(req, res).close();
        res.sendResponseHeader(HTTP_OK);
    }

    /**
     * GET\bh܂B<br>
     * NGXgURIŎw肳ꂽt@C̓ebZ[W{̂ɏo͂܂B
     * 
     * @param req
     *            NGXgIuWFNgB
     * @param res
     *            X|XIuWFNgB
     * @throws FileNotFoundException
     *             NGXgURIŎw肳ꂽt@CI[vłȂꍇɔB
     * @throws IOException
     *             o͗OB
     */
    private void doGet(Request req, Response res) throws FileNotFoundException,
            IOException {
        InputStream is = getContentInputStream(req, res);
        try {
            res.sendResponseHeader(HTTP_OK);
            Utils.copy(is, res.getMessageBody());
        } finally {
            is.close();
        }
    }

}
