package mywebserver;

import static java.net.HttpURLConnection.HTTP_BAD_REQUEST;
import static java.net.HttpURLConnection.HTTP_INTERNAL_ERROR;
import static java.net.HttpURLConnection.HTTP_NOT_FOUND;
import static java.net.HttpURLConnection.HTTP_NOT_IMPLEMENTED;
import static java.net.HttpURLConnection.HTTP_OK;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URLConnection;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.TimeZone;

/**
 * MyWebServer[eBeBNXB
 */
public final class Utils {

    private static final int COPY_BUFFER_SIZE = 8192;

    /**
     * Xe[^XR[hƃXe[^Xt[Ỹ}bsOB
     */
    private static final Map<Integer, String> STATUS_PHRASE;

    /**
     * Xe[^Xt[Y܂B
     */
    static {
        Map<Integer, String> tmp = new HashMap<Integer, String>();
        tmp.put(HTTP_OK, "OK");
        tmp.put(HTTP_BAD_REQUEST, "Bad Request");
        tmp.put(HTTP_NOT_FOUND, "Not Found");
        tmp.put(HTTP_NOT_IMPLEMENTED, "Not Implemented");
        tmp.put(HTTP_INTERNAL_ERROR, "Internal Server Error");
        STATUS_PHRASE = Collections.unmodifiableMap(tmp);
    }

    /**
     * ̓Xg[o̓Xg[ɃRs[܂B
     * 
     * @param is
     *            ̓Xg[B
     * @param os
     *            o̓Xg[B
     * @throws IOException
     *             o͗OB
     */
    public static void copy(InputStream is, OutputStream os) throws IOException {
        InputStream bis = new BufferedInputStream(is);
        OutputStream bos = new BufferedOutputStream(os);
        byte[] buffer = new byte[COPY_BUFFER_SIZE];
        for (int len; (len = bis.read(buffer)) != -1;) {
            bos.write(buffer, 0, len);
        }
        bos.flush();
    }

    /**
     * w肳ꂽt@C̃fBA^Cv擾܂B
     * 
     * @param content
     *            t@CB
     * @return fBA^CvB
     */
    public static String getMediaType(File content) {
        return URLConnection.getFileNameMap().getContentTypeFor(
                content.getName());
    }

    /**
     * Xe[^XR[hɑΉXe[^Xt[Y擾܂B
     * 
     * @param statusCode
     *            Xe[^XR[hB
     * @return Xe[^Xt[YB
     */
    public static String getStatusPhrase(int statusCode) {
        return STATUS_PHRASE.get(statusCode);
    }

    /**
     * ݓHTTP̓t\Ŏ擾܂B
     * 
     * @return ݎHTTPt\B
     */
    public static String getDate() {
        DateFormat df = new SimpleDateFormat("EEE, dd MMM yyyy HH:mm:ss z",
                Locale.US);
        df.setTimeZone(TimeZone.getTimeZone("GMT"));
        return df.format(new Date());
    }

    private Utils() {
    }

}
